<?php

/**
 * @file
 * Provides admin page callbacks for vuejs module.
 */

/**
 * Form builder for admin/config/development/vuejs.
 */
function vuejs_settings_form($form, &$form_state) {
  $libraries = array(
    'vue' => array(
      'default' => 'v2.5.2',
    ),
    'vue_router' => array(
      'default' => 'v3.0.1',
    ),
    'vuex' => array(
      'default' => 'v3.0.0',
    ),
  );

  foreach ($libraries as $library_name => $versions) {
    $variable_name = 'vuejs_version_' . $library_name;

    $current_version = variable_get($variable_name, $versions['default']);

    $form[$library_name] = array(
      '#type' => 'fieldset',
      '#title' => str_replace('_', '-', $library_name),
    );

    $form[$library_name][$variable_name] = array(
      '#type' => 'textfield',
      '#title' => t('Version'),
      '#size' => 9,
      '#required' => TRUE,
      '#default_value' => $current_version,
      '#description' => t('The defaule version is "@version".', array(
        '@version' => $versions['default'],
      )),
      '#element_validate' => array('vuejs_validate_version_text'),
    );
  }

  $form['#submit'][] = 'vuejs_settings_form_submit';

  return system_settings_form($form);
}

/**
 * Additional submit callback for vuejs_settings_form().
 */
function vuejs_settings_form_submit(&$form, &$form_state) {
  libraries_cache_clear();
}
